// src/generated-public/session-browser/endpoints/Session$.ts
import { CodeGenUtil, SdkCache, Validate } from "@accelbyte/sdk";

// src/generated-public/session-browser/definitions/AddPlayerResponse.ts
import { z } from "zod";
var AddPlayerResponse = z.object({ status: z.boolean() });

// src/generated-public/session-browser/definitions/RecentPlayerQueryResponse.ts
import { z as z3 } from "zod";

// src/generated-public/session-browser/definitions/RecentPlayerHistory.ts
import { z as z2 } from "zod";
var RecentPlayerHistory = z2.object({
  created_at: z2.string(),
  namespace: z2.string(),
  other_display_name: z2.string(),
  other_id: z2.string(),
  updated_at: z2.string(),
  user_id: z2.string()
});

// src/generated-public/session-browser/definitions/RecentPlayerQueryResponse.ts
var RecentPlayerQueryResponse = z3.object({ data: z3.array(RecentPlayerHistory) });

// src/generated-public/session-browser/definitions/SessionByUserIDsResponse.ts
import { z as z13 } from "zod";

// src/generated-public/session-browser/definitions/GameSession.ts
import { z as z12 } from "zod";

// src/generated-public/session-browser/definitions/GameSessionSetting.ts
import { z as z4 } from "zod";
var GameSessionSetting = z4.object({
  allow_join_in_progress: z4.boolean(),
  current_internal_player: z4.number().int(),
  current_player: z4.number().int(),
  map_name: z4.string(),
  max_internal_player: z4.number().int(),
  max_player: z4.number().int(),
  mode: z4.string(),
  num_bot: z4.number().int(),
  password: z4.string(),
  settings: z4.record(z4.any())
});

// src/generated-public/session-browser/definitions/MatchMaking.ts
import { z as z9 } from "zod";

// src/generated-public/session-browser/definitions/MatchingAlly.ts
import { z as z8 } from "zod";

// src/generated-public/session-browser/definitions/MatchingParty.ts
import { z as z7 } from "zod";

// src/generated-public/session-browser/definitions/MatchAttributes.ts
import { z as z5 } from "zod";
var MatchAttributes = z5.object({ first_ticket_created_at: z5.number().int() });

// src/generated-public/session-browser/definitions/PartyMember.ts
import { z as z6 } from "zod";
var PartyMember = z6.object({ extra_attributes: z6.record(z6.any()), user_id: z6.string() });

// src/generated-public/session-browser/definitions/MatchingParty.ts
var MatchingParty = z7.object({
  match_attributes: MatchAttributes,
  party_attributes: z7.record(z7.any()),
  party_id: z7.string(),
  party_members: z7.array(PartyMember)
});

// src/generated-public/session-browser/definitions/MatchingAlly.ts
var MatchingAlly = z8.object({ matching_parties: z8.array(MatchingParty) });

// src/generated-public/session-browser/definitions/MatchMaking.ts
var MatchMaking = z9.object({
  channel: z9.string(),
  client_version: z9.string(),
  created_at: z9.string(),
  deployment: z9.string(),
  event: z9.string(),
  game_mode: z9.string(),
  joinable: z9.boolean().nullish(),
  match_id: z9.string(),
  matching_allies: z9.array(MatchingAlly),
  namespace: z9.string(),
  party_attributes: z9.record(z9.any()),
  party_id: z9.string().nullish(),
  queued_at: z9.number().int(),
  region: z9.string(),
  server_name: z9.string(),
  status: z9.string(),
  sub_game_mode: z9.array(z9.string())
});

// src/generated-public/session-browser/definitions/Server.ts
import { z as z11 } from "zod";

// src/generated-public/session-browser/definitions/StatusHistory.ts
import { z as z10 } from "zod";
var StatusHistory = z10.object({ status: z10.string(), time_stamp: z10.string() });

// src/generated-public/session-browser/definitions/Server.ts
var Server = z11.object({
  allocation_id: z11.string(),
  alternate_ips: z11.array(z11.string()),
  cpu_limit: z11.number().int(),
  cpu_request: z11.string(),
  deployment: z11.string(),
  game_version: z11.string(),
  image_version: z11.string(),
  ip: z11.string(),
  is_override_game_version: z11.boolean(),
  last_update: z11.string(),
  mem_limit: z11.number().int(),
  mem_request: z11.string(),
  namespace: z11.string(),
  params: z11.string(),
  pod_name: z11.string(),
  port: z11.number().int(),
  ports: z11.record(z11.number().int()),
  provider: z11.string(),
  region: z11.string(),
  session_id: z11.string(),
  status: z11.string(),
  status_history: z11.array(StatusHistory)
});

// src/generated-public/session-browser/definitions/GameSession.ts
var GameSession = z12.object({
  all_players: z12.array(z12.string()),
  created_at: z12.string(),
  game_session_setting: GameSessionSetting,
  game_version: z12.string(),
  joinable: z12.boolean(),
  match: MatchMaking,
  namespace: z12.string(),
  players: z12.array(z12.string()),
  server: Server,
  session_id: z12.string(),
  session_type: z12.string(),
  spectators: z12.array(z12.string()),
  user_id: z12.string(),
  username: z12.string()
});

// src/generated-public/session-browser/definitions/SessionByUserIDsResponse.ts
var SessionByUserIDsResponse = z13.object({ data: z13.array(GameSession) });

// src/generated-public/session-browser/definitions/SessionQueryResponse.ts
import { z as z15 } from "zod";

// src/generated-public/session-browser/definitions/PagingCursor.ts
import { z as z14 } from "zod";
var PagingCursor = z14.object({ next: z14.string(), previous: z14.string() });

// src/generated-public/session-browser/definitions/SessionQueryResponse.ts
var SessionQueryResponse = z15.object({ pagination: PagingCursor, sessions: z15.array(GameSession) });

// src/generated-public/session-browser/definitions/SessionResponse.ts
import { z as z16 } from "zod";
var SessionResponse = z16.object({
  all_players: z16.array(z16.string()),
  created_at: z16.string(),
  game_session_setting: GameSessionSetting,
  game_version: z16.string(),
  joinable: z16.boolean(),
  match: MatchMaking,
  namespace: z16.string(),
  players: z16.array(z16.string()),
  server: Server,
  session_id: z16.string(),
  session_type: z16.string(),
  spectators: z16.array(z16.string()),
  user_id: z16.string(),
  username: z16.string()
});

// src/generated-public/session-browser/endpoints/Session$.ts
var Session$ = class {
  constructor(axiosInstance, namespace, cache = false) {
    this.axiosInstance = axiosInstance;
    this.namespace = namespace;
    this.cache = cache;
  }
  getGamesession(queryParams) {
    const params = { limit: 25, ...queryParams };
    const url = "/sessionbrowser/namespaces/{namespace}/gamesession".replace("{namespace}", this.namespace);
    const resultPromise = this.axiosInstance.get(url, { params });
    const res = () => Validate.responseType(() => resultPromise, SessionQueryResponse, "SessionQueryResponse");
    if (!this.cache) {
      return SdkCache.withoutCache(res);
    }
    const cacheKey = url + CodeGenUtil.hashCode(JSON.stringify({ params }));
    return SdkCache.withCache(cacheKey, res);
  }
  createGamesession(data) {
    const params = {};
    const url = "/sessionbrowser/namespaces/{namespace}/gamesession".replace("{namespace}", this.namespace);
    const resultPromise = this.axiosInstance.post(url, data, { params });
    return Validate.responseType(() => resultPromise, SessionResponse, "SessionResponse");
  }
  getGamesessionBulk(queryParams) {
    const params = { ...queryParams };
    const url = "/sessionbrowser/namespaces/{namespace}/gamesession/bulk".replace("{namespace}", this.namespace);
    const resultPromise = this.axiosInstance.get(url, { params });
    const res = () => Validate.responseType(() => resultPromise, SessionByUserIDsResponse, "SessionByUserIDsResponse");
    if (!this.cache) {
      return SdkCache.withoutCache(res);
    }
    const cacheKey = url + CodeGenUtil.hashCode(JSON.stringify({ params }));
    return SdkCache.withCache(cacheKey, res);
  }
  getRecentplayer_ByUserId(userID) {
    const params = {};
    const url = "/sessionbrowser/namespaces/{namespace}/recentplayer/{userID}".replace("{namespace}", this.namespace).replace("{userID}", userID);
    const resultPromise = this.axiosInstance.get(url, { params });
    const res = () => Validate.responseType(() => resultPromise, RecentPlayerQueryResponse, "RecentPlayerQueryResponse");
    if (!this.cache) {
      return SdkCache.withoutCache(res);
    }
    const cacheKey = url + CodeGenUtil.hashCode(JSON.stringify({ params }));
    return SdkCache.withCache(cacheKey, res);
  }
  deleteGamesession_BySessionId(sessionID) {
    const params = {};
    const url = "/sessionbrowser/namespaces/{namespace}/gamesession/{sessionID}".replace("{namespace}", this.namespace).replace("{sessionID}", sessionID);
    const resultPromise = this.axiosInstance.delete(url, { params });
    return Validate.responseType(() => resultPromise, SessionResponse, "SessionResponse");
  }
  getGamesession_BySessionId(sessionID) {
    const params = {};
    const url = "/sessionbrowser/namespaces/{namespace}/gamesession/{sessionID}".replace("{namespace}", this.namespace).replace("{sessionID}", sessionID);
    const resultPromise = this.axiosInstance.get(url, { params });
    const res = () => Validate.responseType(() => resultPromise, SessionResponse, "SessionResponse");
    if (!this.cache) {
      return SdkCache.withoutCache(res);
    }
    const cacheKey = url + CodeGenUtil.hashCode(JSON.stringify({ params }));
    return SdkCache.withCache(cacheKey, res);
  }
  updateGamesession_BySessionId(sessionID, data) {
    const params = {};
    const url = "/sessionbrowser/namespaces/{namespace}/gamesession/{sessionID}".replace("{namespace}", this.namespace).replace("{sessionID}", sessionID);
    const resultPromise = this.axiosInstance.put(url, data, { params });
    return Validate.responseType(() => resultPromise, SessionResponse, "SessionResponse");
  }
  createJoin_BySessionId(sessionID, data) {
    const params = {};
    const url = "/sessionbrowser/namespaces/{namespace}/gamesession/{sessionID}/join".replace("{namespace}", this.namespace).replace("{sessionID}", sessionID);
    const resultPromise = this.axiosInstance.post(url, data, { params });
    return Validate.responseType(() => resultPromise, SessionResponse, "SessionResponse");
  }
  createPlayer_BySessionId(sessionID, data) {
    const params = {};
    const url = "/sessionbrowser/namespaces/{namespace}/gamesession/{sessionID}/player".replace("{namespace}", this.namespace).replace("{sessionID}", sessionID);
    const resultPromise = this.axiosInstance.post(url, data, { params });
    return Validate.responseType(() => resultPromise, AddPlayerResponse, "AddPlayerResponse");
  }
  deleteLocald_BySessionId(sessionID) {
    const params = {};
    const url = "/sessionbrowser/namespaces/{namespace}/gamesession/{sessionID}/localds".replace("{namespace}", this.namespace).replace("{sessionID}", sessionID);
    const resultPromise = this.axiosInstance.delete(url, { params });
    return Validate.responseType(() => resultPromise, SessionResponse, "SessionResponse");
  }
  updateSetting_BySessionId(sessionID, data) {
    const params = {};
    const url = "/sessionbrowser/namespaces/{namespace}/gamesession/{sessionID}/settings".replace("{namespace}", this.namespace).replace("{sessionID}", sessionID);
    const resultPromise = this.axiosInstance.put(url, data, { params });
    return Validate.responseType(() => resultPromise, SessionResponse, "SessionResponse");
  }
  deletePlayer_BySessionId_ByUserId(sessionID, userID) {
    const params = {};
    const url = "/sessionbrowser/namespaces/{namespace}/gamesession/{sessionID}/player/{userID}".replace("{namespace}", this.namespace).replace("{sessionID}", sessionID).replace("{userID}", userID);
    const resultPromise = this.axiosInstance.delete(url, { params });
    return Validate.responseType(() => resultPromise, AddPlayerResponse, "AddPlayerResponse");
  }
};

// src/generated-public/session-browser/SessionApi.ts
import { ApiUtils, Network } from "@accelbyte/sdk";
function SessionApi(sdk, args) {
  const sdkAssembly = sdk.assembly();
  const namespace = (args == null ? void 0 : args.namespace) ? args == null ? void 0 : args.namespace : sdkAssembly.namespace;
  const cache = (args == null ? void 0 : args.cache) ? args == null ? void 0 : args.cache : sdkAssembly.cache;
  const requestConfig = ApiUtils.mergedConfigs(sdkAssembly.config, args);
  async function getGamesession(queryParams) {
    const $ = new Session$(Network.create(requestConfig), namespace, cache);
    const resp = await $.getGamesession(queryParams);
    if (resp.error)
      throw resp.error;
    return resp.response.data;
  }
  async function createGamesession(data) {
    const $ = new Session$(Network.create(requestConfig), namespace, cache);
    const resp = await $.createGamesession(data);
    if (resp.error)
      throw resp.error;
    return resp.response.data;
  }
  async function getGamesessionBulk(queryParams) {
    const $ = new Session$(Network.create(requestConfig), namespace, cache);
    const resp = await $.getGamesessionBulk(queryParams);
    if (resp.error)
      throw resp.error;
    return resp.response.data;
  }
  async function getRecentplayer_ByUserId(userID) {
    const $ = new Session$(Network.create(requestConfig), namespace, cache);
    const resp = await $.getRecentplayer_ByUserId(userID);
    if (resp.error)
      throw resp.error;
    return resp.response.data;
  }
  async function deleteGamesession_BySessionId(sessionID) {
    const $ = new Session$(Network.create(requestConfig), namespace, cache);
    const resp = await $.deleteGamesession_BySessionId(sessionID);
    if (resp.error)
      throw resp.error;
    return resp.response.data;
  }
  async function getGamesession_BySessionId(sessionID) {
    const $ = new Session$(Network.create(requestConfig), namespace, cache);
    const resp = await $.getGamesession_BySessionId(sessionID);
    if (resp.error)
      throw resp.error;
    return resp.response.data;
  }
  async function updateGamesession_BySessionId(sessionID, data) {
    const $ = new Session$(Network.create(requestConfig), namespace, cache);
    const resp = await $.updateGamesession_BySessionId(sessionID, data);
    if (resp.error)
      throw resp.error;
    return resp.response.data;
  }
  async function createJoin_BySessionId(sessionID, data) {
    const $ = new Session$(Network.create(requestConfig), namespace, cache);
    const resp = await $.createJoin_BySessionId(sessionID, data);
    if (resp.error)
      throw resp.error;
    return resp.response.data;
  }
  async function createPlayer_BySessionId(sessionID, data) {
    const $ = new Session$(Network.create(requestConfig), namespace, cache);
    const resp = await $.createPlayer_BySessionId(sessionID, data);
    if (resp.error)
      throw resp.error;
    return resp.response.data;
  }
  async function deleteLocald_BySessionId(sessionID) {
    const $ = new Session$(Network.create(requestConfig), namespace, cache);
    const resp = await $.deleteLocald_BySessionId(sessionID);
    if (resp.error)
      throw resp.error;
    return resp.response.data;
  }
  async function updateSetting_BySessionId(sessionID, data) {
    const $ = new Session$(Network.create(requestConfig), namespace, cache);
    const resp = await $.updateSetting_BySessionId(sessionID, data);
    if (resp.error)
      throw resp.error;
    return resp.response.data;
  }
  async function deletePlayer_BySessionId_ByUserId(sessionID, userID) {
    const $ = new Session$(Network.create(requestConfig), namespace, cache);
    const resp = await $.deletePlayer_BySessionId_ByUserId(sessionID, userID);
    if (resp.error)
      throw resp.error;
    return resp.response.data;
  }
  return {
    getGamesession,
    createGamesession,
    getGamesessionBulk,
    getRecentplayer_ByUserId,
    deleteGamesession_BySessionId,
    getGamesession_BySessionId,
    updateGamesession_BySessionId,
    createJoin_BySessionId,
    createPlayer_BySessionId,
    deleteLocald_BySessionId,
    updateSetting_BySessionId,
    deletePlayer_BySessionId_ByUserId
  };
}

// src/generated-public/SessionBrowser.ts
var apis = {
  SessionApi
};
var SessionBrowser = apis;

// src/generated-public/session-browser/definitions/ActiveCustomGameResponse.ts
import { z as z18 } from "zod";

// src/generated-public/session-browser/definitions/CustomGameResponse.ts
import { z as z17 } from "zod";
var CustomGameResponse = z17.object({
  all_players: z17.array(z17.string()),
  created_at: z17.string(),
  game_session_setting: GameSessionSetting,
  joinable: z17.boolean(),
  namespace: z17.string(),
  players: z17.array(z17.string()),
  server: Server,
  session_id: z17.string(),
  session_type: z17.string(),
  spectators: z17.array(z17.string())
});

// src/generated-public/session-browser/definitions/ActiveCustomGameResponse.ts
var ActiveCustomGameResponse = z18.object({ pagination: PagingCursor, sessions: z18.array(CustomGameResponse) });

// src/generated-public/session-browser/definitions/ActiveMatchmakingGameResponse.ts
import { z as z19 } from "zod";
var ActiveMatchmakingGameResponse = z19.object({ pagination: PagingCursor, sessions: z19.array(GameSession) });

// src/generated-public/session-browser/definitions/AddPlayerRequest.ts
import { z as z20 } from "zod";
var AddPlayerRequest = z20.object({ as_spectator: z20.boolean(), user_id: z20.string() });

// src/generated-public/session-browser/definitions/AdminSessionResponse.ts
import { z as z21 } from "zod";
var AdminSessionResponse = z21.object({
  all_players: z21.array(z21.string()),
  created_at: z21.string(),
  game_session_setting: GameSessionSetting,
  game_version: z21.string(),
  joinable: z21.boolean(),
  match: MatchMaking,
  namespace: z21.string(),
  players: z21.array(z21.string()),
  server: Server,
  session_id: z21.string(),
  session_type: z21.string(),
  spectators: z21.array(z21.string()),
  user_id: z21.string(),
  username: z21.string()
});

// src/generated-public/session-browser/definitions/CountActiveSessionResponse.ts
import { z as z22 } from "zod";
var CountActiveSessionResponse = z22.object({
  custom_game: z22.number().int(),
  matchmaking_game: z22.number().int(),
  total: z22.number().int()
});

// src/generated-public/session-browser/definitions/CreateSessionRequest.ts
import { z as z23 } from "zod";
var CreateSessionRequest = z23.object({
  game_session_setting: GameSessionSetting,
  game_version: z23.string(),
  namespace: z23.string(),
  session_type: z23.string(),
  username: z23.string()
});

// src/generated-public/session-browser/definitions/GetSessionHistoryDetailedResponseItem.ts
import { z as z26 } from "zod";

// src/generated-public/session-browser/definitions/SessionPlayerHistory.ts
import { z as z24 } from "zod";
var SessionPlayerHistory = z24.object({ Action: z24.string(), Date: z24.string(), UserID: z24.string() });

// src/generated-public/session-browser/definitions/SessionPlayerJoining.ts
import { z as z25 } from "zod";
var SessionPlayerJoining = z25.object({ Date: z25.string(), State: z25.string(), UserID: z25.string() });

// src/generated-public/session-browser/definitions/GetSessionHistoryDetailedResponseItem.ts
var GetSessionHistoryDetailedResponseItem = z26.object({
  _id: z26.string(),
  channel: z26.string(),
  client_version: z26.string(),
  created_at: z26.string(),
  event_description: z26.string(),
  event_name: z26.string(),
  game_mode: z26.string(),
  joinable: z26.boolean(),
  joining: z26.array(SessionPlayerJoining),
  match_id: z26.string(),
  matching_allies: z26.array(MatchingAlly),
  namespace: z26.string(),
  party_id: z26.string().nullish(),
  players: z26.array(SessionPlayerHistory),
  region: z26.string(),
  removed_reason: z26.string(),
  server_name: z26.string(),
  session_type: z26.string(),
  status: z26.string(),
  user_id: z26.string()
});

// src/generated-public/session-browser/definitions/GetSessionHistorySearchResponseItemV2.ts
import { z as z27 } from "zod";
var GetSessionHistorySearchResponseItemV2 = z27.object({
  _id: z27.string(),
  created_at: z27.string(),
  game_mode: z27.string(),
  joinable: z27.boolean(),
  joining: z27.array(SessionPlayerJoining),
  match_id: z27.string(),
  namespace: z27.string(),
  players: z27.array(SessionPlayerHistory),
  removed_reason: z27.string(),
  session_type: z27.string(),
  status: z27.string(),
  sub_game_mode: z27.array(z27.string()),
  user_id: z27.string()
});

// src/generated-public/session-browser/definitions/GetSessionHistorySearchResponseV2.ts
import { z as z29 } from "zod";

// src/generated-public/session-browser/definitions/Pagination.ts
import { z as z28 } from "zod";
var Pagination = z28.object({ first: z28.string(), last: z28.string(), next: z28.string(), previous: z28.string() });

// src/generated-public/session-browser/definitions/GetSessionHistorySearchResponseV2.ts
var GetSessionHistorySearchResponseV2 = z29.object({ data: z29.array(GetSessionHistorySearchResponseItemV2), pagination: Pagination });

// src/generated-public/session-browser/definitions/JoinGameSessionRequest.ts
import { z as z30 } from "zod";
var JoinGameSessionRequest = z30.object({ password: z30.string() });

// src/generated-public/session-browser/definitions/UpdateSessionRequest.ts
import { z as z31 } from "zod";
var UpdateSessionRequest = z31.object({ game_max_player: z31.number().int() });

// src/generated-public/session-browser/definitions/UpdateSettingsRequest.ts
import { z as z32 } from "zod";
var UpdateSettingsRequest = z32.any();

// src/generated-public/session-browser/definitions/Error.ts
import { z as z33 } from "zod";
var Error = z33.object({ errorCode: z33.number().int(), errorMessage: z33.string() });

// src/generated-public/session-browser/definitions/ErrorResponseV2.ts
import { z as z34 } from "zod";
var ErrorResponseV2 = z34.object({
  attributes: z34.record(z34.string()),
  errorCode: z34.number().int(),
  errorMessage: z34.string(),
  message: z34.string(),
  name: z34.string()
});

// src/generated-public/session-browser/definitions/ErrorV1.ts
import { z as z35 } from "zod";
var ErrorV1 = z35.object({ errorCode: z35.number().int(), errorMessage: z35.string() });
export {
  ActiveCustomGameResponse,
  ActiveMatchmakingGameResponse,
  AddPlayerRequest,
  AddPlayerResponse,
  AdminSessionResponse,
  CountActiveSessionResponse,
  CreateSessionRequest,
  CustomGameResponse,
  Error,
  ErrorResponseV2,
  ErrorV1,
  GameSession,
  GameSessionSetting,
  GetSessionHistoryDetailedResponseItem,
  GetSessionHistorySearchResponseItemV2,
  GetSessionHistorySearchResponseV2,
  JoinGameSessionRequest,
  MatchAttributes,
  MatchMaking,
  MatchingAlly,
  MatchingParty,
  Pagination,
  PagingCursor,
  PartyMember,
  RecentPlayerHistory,
  RecentPlayerQueryResponse,
  Server,
  Session$,
  SessionApi,
  SessionBrowser,
  SessionByUserIDsResponse,
  SessionPlayerHistory,
  SessionPlayerJoining,
  SessionQueryResponse,
  SessionResponse,
  StatusHistory,
  UpdateSessionRequest,
  UpdateSettingsRequest
};
